#!/usr/bin/perl

=pod

=head1 NAME

log2seplog -  


=head1 DESCRIPTION

Amidaのログファイル（非圧縮）を読み込み，
メソッドリターン行に呼び出し元情報を付加する．

=cut

use strict;
use warnings;

my @callstack = ();        ## コールスタック（要素はメソッド呼び出し行の情報丸ごと全部（中括弧と改行を除く）
##  トップに現在見ているオブジェクト（呼び出されクラス）のID，以下呼び出し元が底まで並ぶ．

$callstack[0]=-1;          ## reserved for root method of this execution trace

while (<>) {
	chomp;
	
	my $line = $_;

	if( /^\@thread/ ){ 
	}  
	if (/{/) {
		$line =~ s/\{//;
		push (@callstack,$line);
	}
	elsif (/}/) {
		pop @callstack;
		my $num = @callstack - 1;
		
		$line = $line . " returnTo: ". $callstack[$num];
	}
	print "$line\n";
}

exit(0);
